//
//  ViewController.h
//  AS355
//
//  Created by Claus Richter on 2/5/13.
//  Copyright (c) 2013 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

#import <MessageUI/MFMailComposeViewController.h>

#import "VDTextFieldWithFixedDropDown.h"
#import "StartPage.h"



@interface ViewController : UIViewController <MFMailComposeViewControllerDelegate, UITableViewDataSource, UITableViewDelegate ,UIScrollViewDelegate>  {
    
    NSMutableArray *arrayCustomStations;
    NSMutableDictionary *customStationDictionary;
    NSMutableArray *arrayCustomFlightDataElements;
    
    NSString *allEquipmentString, *equipSingleString, *alternateACType, *alternateCallsign, *alternateConfig, *inputPressureAlt, *priceCategoryOfSelectedAircraft, *trialCheck;
    
    int flagUsingAlternateEquipment, flagNoLatLimit;
    int triggerFuelAnimation, customStationID, flagAddCustomStation, indexToAddOrRemove, flagReopenFlightSettings, flagSpecialPHIFlightSettingPage, flagWeHaveVariableTanks, useTankNumberInArray, addToStartIDforVariableTanks;
;
    
    
    float penaltyWeight, penaltyFtMin, buttonIDbuttSel;
    
    UIView *enterView;
    
    float yPixSliderValue, restrictingHoistWeight;
    
    float movedEquipLong, movedEquiplat, symSizeX, symSizeY;
    
    int flagLockReset, previousACTopViewState, enduranceHours, enduranceMinutesOnly, flagChangeCallsign;
    int flagEquipItemHasMoved;
    
    NSArray *itemsGuidance;
    NSString *internalFlightID, *translatedSymbolName, *previousImageToLoad, *previousACImageToLoad;
    
    NSMutableDictionary *fuelInterpolationDictionary;
    NSMutableDictionary *PHIequipListDictionary;
    
    NSMutableArray *arrayFuelVolumeLONG;
    NSMutableArray *arrayFuelMomentLONG;
    
     NSMutableArray *callsignArray;
    
    NSMutableArray *arrayFuelVolumeLAT;
    NSMutableArray *arrayFuelMomentLAT;
    
    NSMutableArray *arrayMyFleetCallsigns;
    NSMutableArray *arrayMyFleetACTypes;
    NSMutableArray *arrayMyFleetACData;
    NSMutableDictionary *myFleetDictionary;
    
    NSMutableArray *arrayDictAllAircraft;
    NSMutableArray *arrayInternalFlightNumber;
    
    NSMutableDictionary *ACimagesDictionary;
    
    NSMutableArray *tempArraySeatWgt;
    NSMutableArray *tempArraySeatName;
    
    NSMutableArray *arrayPersonsOnBoard;
    
    NSMutableArray *allFlightsMasterArray;
    
    NSMutableArray *allLegsPerFlightArray;
    
    NSMutableDictionary *flightSettingsDictionary;
    
    NSMutableDictionary *guidanceDictionary;
    
    NSMutableArray *availableACTypes;
    
    NSMutableDictionary *manifestLogoDictionary;
    
    
    NSMutableDictionary *legSettingsDictionary;
    
    UIPanGestureRecognizer *panRecognizerForGhost;
    UIPanGestureRecognizer *panRecognizerForEquipment;
    
    NSNumberFormatter *decimalFormatter;
  
    CAShapeLayer *shapeLayerCG1;
    CAShapeLayer *shapeLayerCG2;
    CAShapeLayer *shapeLayerCGMargin;
    
    CAShapeLayer *shapeLayerCG1Lat;
    
    
    CAShapeLayer *shapeLayerFreakViewCG1;
    CAShapeLayer *shapeLayerFreakViewCG2;
    CAShapeLayer *shapeLayerFreakViewCG1Lat;
    CAShapeLayer *shapeLayerFreakViewCG1Margin;
    
    NSString *previousACType;

    NSString *summaryDateStamp;
    int legFlightTimeMinutes;
    
    UIImageView *ghostImage;
    
    // datepicker
    
    UIDatePicker *datepick;
    
    NSString *timeStampForPDF;
   
   
    float availableExternalLoad, maxHoistLoad, maxMTOWforHoist;

    
    int flagReportEnvelopeExceeded;
    
    NSIndexPath *selectedPathTransfer;

    //global vars to store crew, locations and helicopters
    
    
    int btnHOLDidTransfer;
      
    NSString *previousChartName;
    
   
    float summaryBoxHeight;
    
    
    NSMutableArray *crew;
    NSMutableArray *crew_sectioned;
    NSMutableArray *crew_types;
    NSString *crew_lastLocation;
    NSMutableArray *locations;

    
    NSString *lastupdate_helicopters;
    NSString *lastupdate_crew;
    NSString *forcedUnit;
    
    NSString *customer;
    NSString *serverpath;
    NSString *serverhost;
    
    NSString *serverpath_new;
    
    NSString *serverpath_standard;
    NSString *serverpath_new_standard;
    NSString *serverhost_standard;
    
    
    NSString *serverpath_alternate;
    NSString *serverpath_new_alternate;
    NSString *serverhost_alternate;
    
    
    NSString *fleetcontrolCode;
    
    UITextField *valueField;
    
    float mostFWDCGpoint, mostFWDweight;
    
    float packageStart, packageEND;
    
    float listoItemNr;
    
    float fuelMoment;
    
    float fuelWeight;
    float fuelVolume;
    
    int guidanceLegCheckOK;
    

    
    UIImage *buttonRed;
    
    UIImage *buttonGrey;
    
    UIImage *buttonBlue;
    
    UIButton *buttonToWarn;

    
    
    float lineZFW, lineFuel, lineTOW, lineLDW,  lineEnd, lineOptionsEnd, lineDOM, lineROM, lineTL,lineEquipment, lineSeats, lineExternal, lineDualControls, lineSeatsOccupied, lineJackets, linePatient, lineFreeLoad, lineFuelTankTotal, lineExtShelf, lineFirstFuelTankTO, lineFirstFuelTankLD, amountOfFuelTanksTO, amountOfFuelTanksLD, firstLineFuelTank;
    
    double bew, momlong, momlat, armlong, armlat;
    
    
    double fuelTO, fuelLD;
    
    NSMutableArray *arrayConfigurations;
    
    NSMutableArray *arrayConfigButtons;
    
    NSString *defaultConfigName;
    
 
    
    
    // new CG envelope
    
    
    NSString *xVal;
    
    NSString *yVal;
    
    NSString *xValcg;
    
    NSString *yValcg;
    
    UIBezierPath *pathCGenvelope;
    
    
    
    float leftBorderOfMeasureBox, measureBoxWidth, topBorderOfMeasureBox, measureBoxHeight, xPixelFactor, yPixelFactor, xAxisLeft, xAxisRight, yAxisBottom, yAxisTop;
    
    float leftBorderOfMeasureBox2, measureBoxWidth2, topBorderOfMeasureBox2, measureBoxHeight2, xPixelFactor2, yPixelFactor2, xAxisLeft2, xAxisRight2, yAxisBottom2, yAxisTop2;
    
    float leftBorderOfMeasureBoxLAT, xAxisLeftLAT, xPixelFactorLAT, topBorderOfMeasureBoxLAT, yAxisTopLAT, yPixelFactorLAT;
    
    float leftBorderOfMeasureBoxLAT2, xAxisLeftLAT2, xPixelFactorLAT2, topBorderOfMeasureBoxLAT2, yAxisTopLAT2, yPixelFactorLAT2;

    float drawToFixedPointX, drawToFixedPointY;
    
    
    UIImageView *ACtop;
    
    UIImageView *ACtop_Warning;
    
    
    UIImage *ACtopImage;
    
    UIImage *ACtop_WarningImage;
    
    
    float flagSlump, flagSkies ;
    
    float OGEinterpolPAResult;
    
    int flagPerfBoxOn;
    
    
    int justCreatedNewFlight;
    
    //***********************************************************************************************************
    //***********************************************************************************************************
    //***********************************************************************************************************
    
    
    
    UILabel *dL;
    UILabel *buttonResult;
    UILabel *buttonChartName;
    
    float selectedChartButton;
    
    float resultFromComputations;
    NSString *chartNameForComputation;
    NSString *userNameForComputation;
    NSString *unitNameForComputation;
    
    int chartNumberForResult;
    
    
    NSString *resultUnit;
    
    NSString *chartNameToLoad;
    
    NSString *chartUserName;
    
    NSString *chartNameToProcess;
    NSMutableArray *buttonChartNamesToProcess;
    
    NSMutableArray *perfButtonChartNames;
    NSMutableArray *perfButtonUserNames;
    
    NSString *prevStation;
    
    int actualButtonNumber;
    
    
    
    int amountofButtonsNeeded;
    int numberOfChartsForThisAircraft;
    int buttonNumber;
    
    NSMutableArray *infoFilesGeneral;
    
    NSMutableArray *arrayAvailableListIDs;
    
    NSArray *availableCurves;
    
    NSString *arrayKey;
    
    
    NSString *fuelUnits;
  
    
    NSString *alternateCGenvelope;
    
    NSArray *availableCurvesArray;
    
    NSString *importedText;
    
    NSString *serverUrl;
    NSString *ACCategory;
    NSString *ACmanufacturer;

    NSString *AC_Type;
    NSString *ACVariant;
    
    float splitResult1, splitResult2;
    
    
    UIAlertController *alertController;
    
    NSString *chartNameForImage;
    
    NSString *chartNameForThisInfoFile;
    
    NSString *crossLineSequence;
    
    NSString *untiResult;
    
    NSString *loadedBEWUnits;
    
    NSArray *infoArray;
    NSArray *infoPartArray;
    NSArray *curvesArray;
    
    float chartNumberShown, alertFlag;
    
    NSArray *chartsArray;
    
    int partNumberToCompute, flagInputDataOutOfRange, flagOutputDataOutOfRange;
    
    int yToX, nChart, nCross;
    
    int infoPartNumber, numberOfComputationParts;
    
    int newWPDdataAvialable, flagThisPartResultContainsTransferValue;
    
    float buttonIDtransfer;
     
    float totalSeatWeight,  yBottomManifest;
    
    int currentEquipItemNumber;
      
    // special equip list
    
    NSMutableArray *arrayACType;
    NSMutableArray *arrayACRegistration;
    NSMutableArray *arrayBaseName;
    NSMutableArray *arrayConfigurationName;
    NSMutableArray *arrayPackageName;
    NSMutableArray *arrayUnitseName;
    NSMutableArray *arrayConfigItemName;
    NSMutableArray *arrayConfigItemWeight;
    NSMutableArray *arrayConfigItemArmLong;
    NSMutableArray *arrayConfigItemMomLong;
    NSMutableArray *arrayConfigItemArmLat;
    NSMutableArray *arrayConfigItemMomLat;
    NSMutableArray *arrayConfigIteminOut;
    NSMutableArray *arrayConfigItemLocked;
    NSMutableArray *arrayConfigItemData;
    NSMutableArray *arrayConfigItemMoved;
    
    NSMutableArray *arrayConfigItemAltLong;
    NSMutableArray *arrayConfigItemAltLat;
    NSMutableArray *arrayConfigItemMovable;
    NSMutableArray *arrayConfigItemTrigger;
    
    NSMutableArray *arrayConfigItemItemR1;
    NSMutableArray *arrayConfigItemItemR2;
    NSMutableArray *arrayConfigItemItemR3;
    
   
    

 
    NSMutableArray *arrayHoistRestrictions;
    
    float totalSpecialEquipWeight, totalSpecialEquipMoment, totalSpecialEquipMomentLat, supplyFuelVolume;
    
    NSString *currentConfigName;
    NSString *currentBaseName;
    NSString *maxExternalLoadString;
    int lineRelevantForExternalLoad;
   
    
    NSString *stationName1;
    float stationWeight1;
    float stationArm1;
    float stationMoment1;
    float stationArmLat1;
    float stationMomentLat1;;
    
    NSString *stationName2;
    float stationWeight2;
    float stationArm2;
    float stationMoment2;
    float stationArmLat2;
    float stationMomentLat2;
    
    int foundMatch1;
    int foundMatch2;
    
    int matchItemID1;
    int matchItemID2;
    
    int flagEnterCrewListMode;
    
    
    NSMutableArray *dispatcherFlights;
    NSString *crew_lastFlight;
    
    
    NSMutableArray *dispatcherPaxNames;
    NSMutableArray *dispatcherPaxWeight;
    
    
    NSMutableArray *dispatcherCrewNames;
    NSMutableArray *dispatcherCrewWeight;
    
    NSString *vFlightID;
    NSString *vLegID;
    
    float weightValue;
    
    float lZFW, lZFWArm, lZFWMom, lZFWArmLat, lZFWMomLAt,  vTOW, vTOWArm, vTOWMom, vTOWArmLat, vTOWMomLAt, vLDW, vLDWArm, vLDWMom, vLDWArmLat, vLDWMomLAt;
    
    NSData *signatureImageData; //saved as signatureImage
    UIImage *loadedSignatureImage; //mountSignatureImageToLoadManifest
    
    NSData *signature2ImageData; //saved as signatureImage
    UIImage *loadedSignature2Image; //mountSignatureImageToLoadManifest
    
    
    NSString *equipListID;
    
    
    NSString *actypeForConfig;
    
    int flagAlarmCGLong, flagOverwriteOptionsDefault, flagUpdateFleetControlDataOnly;
    int CGwithinEnvelope1;
    int CGwithinEnvelope2;
    int CGwithinMargin;
    
    
    NSString *dispatchedConfiguration;
    
    NSString *fuelUnitsPresented, *autoLandingFuelSetting;
    
    int tankNumber, flagMultipleFuelTanks;
    
     NSString *importedAllEquipmentString;
    
    NSString *pilotNameToRetain;
    NSString *pilotWeightToRetain;
    NSString *copilotNameToRetain;
    NSString *copilotWeightToRetain;
    
   
    
    int altenateLine;
    
    int fuelStart, fuelEnd;
    float fuelSliderTopPosition;
    
    NSMutableArray *arrayLinesToRetain;
    NSMutableArray *arrayNamesToRetain;
    NSMutableArray *arrayWeightsToRetain;
 
    
    NSString *dateOfWeighing;
    NSString *weighingRemarks;
    NSString *previousSeatName;
    NSString *jsonString;
    
    UIView *buttonView;
    
    
    NSString *previousOriginalWeightUnits, *previousOriginalFuelUnits, *equipMessage, *equipWarningMessage;

    UITableViewCell *previousCell;
  
   
}

- (void) remoteControlCreateNewFlight;


- (void) addHelicopterButtonsMyFleet;
- (void) combineACinArrayDictAllAircraft;
- (void) startLoadingACsFromFleetControl;
- (void) showFlightManagerWithNewACData;

- (void) showLoadDataFM;

- (void) loadHelicoptersFromServerVoid;

- (IBAction)actionShowEquiplistViewFromFlightSettings:(id)sender;

extern NSString *selectedUnitForItems, *selectedUnitForFuel, *triggerCopySliderSettingsWithFlightID, *specialdata1, *specialdata2, *formatString1, *formatString2, *formatString3, *formatString4, *fuelEnterMode, *calcMode, *unitsDistance, *unitsElevation, *unitsAltimeter;

extern float displayWindow, factorApplyToNativeWeightforItems, factorApplyToNativeFuelWeight, factorApplyToNativeFuelVolumeGalLiter, factorApplyToNativeDistanceInchMM, factorApplyToNativeDistanceInchMMforFuel, factorApplyToNativeMoment, factorApplyToNativeFuelMoment, incrementVariSlider1, incrementVariSlider2, incrementVariSlider3, incrementVariSlider4, MTOWfromEnvelope,  specificFuelDensityValue, fuelOnBoardKg, lineForPenaltyOptionsEnd, lineOptions, maxHoistH145standard, maxHoistH145special;

extern UIColor *  const COLOR_LIGHT_BLUE;

extern int flagManifestOpen, triggerOpenChart, triggerSetDefaultsForPerformanceCharts, triggerDoNotShowPerfChart, flagDoNotCreateFlightNow, flagClimbEndMustBeHigherThanElevation, flagTriggerSpecialCreateFlight,flagCheckForAvailableAircrafts, flagCopyFlight, flagWeHavePenaltyData;


@property (strong, nonatomic) StartPage *startPage;

@property (strong, nonatomic) IBOutletCollection(UIView) NSArray *collectionViewFlightLegData;

- (void) MainRoutine;



- (void)actionFullScreenPerfChart: (float)receivedChartState ;

- (void)actionSendPowerCheckEmail: (float)receivedTorque1  sendTorque2:(float)receivedTorque2 sendITT1:(float)receivedITT1 sendITT2:(float)receivedITT2 sendMaxITT1:(float)receivedMaxITT1 sendMaxITT2:(float)receivedMaxITT2  sendMargin1:(float)receivedMargin1  sendMargin2:(float)receivedMargin2 sendResult1:(NSString*)receivedResult1 sendResult2:(NSString*)receivedResult2 sendCheckType:(NSString*)receivedCheckType;


@property (weak, nonatomic) IBOutlet UIScrollView *scrollView;


//***********************************************************************************************************


@property (strong, nonatomic) IBOutlet UIView *viewUniversalButtons;


@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewUniversalButtons;

- (void)remoteButSelHeli :(int)ACbuttonID;

- (void)remoteTest;


@property (weak, nonatomic) IBOutlet UIView *viewFilterNVG;

extern int externalLoadActivated, hoistActivated, flagOneDoorOff;



extern float transferLineInput, transferAxisInput, warningsOnOff, hoistLoadAttached, externalLoadAttached;

extern float configBEW, configMoment, configMomLat;

@property (weak, nonatomic) IBOutlet UILabel *bundleVersion;

extern float dListInputFieldTag, KIAS, wgtTOWkg, transferValue, fuelPercent;

extern NSString *pilotNameGlobal, *vFlightRegGlobal;

@property (weak, nonatomic) IBOutlet UITextField *inputCommunicationKey;

@property (strong, nonatomic) IBOutlet UIView *viewFleetManager;
@property (strong, nonatomic) IBOutlet UIView *viewLoadDataFleetManager;

@property (strong, nonatomic) IBOutlet UIActivityIndicatorView *spinner2;



- (void)dListSetInputField;

- (void)dListCancel;

- (void) closeFleetManagerView;
- (void) closeFleetManagerAndOpenWBpage;


@property (strong, nonatomic) IBOutletCollection(UILabel) NSArray *labelCollectionWeightUnits;

@property (strong, nonatomic) IBOutletCollection(UILabel) NSArray *labelCollectionCGunits;


extern float memX1, memX2 , memX3 , memY1 , memY2 , memY3 , bNr ;

extern float wantedX , resultY , resultY1 ,  resultY2 , x1 , x2 , curveCut ;


extern float OAT, Hp, wantedX, headWind;


extern float yIn, lineIn, resultX, engineTorque, resultPwr1;




// datepick

- (IBAction) datepickButtonOK;

- (IBAction) datepickSetToNowButton;

- (IBAction) datepickCancelButton;

@property (nonatomic, retain)IBOutlet UIDatePicker *datepick;


@property (strong, nonatomic) IBOutlet UIView *viewBase;



//Dennis START



- (IBAction)buttonActionImportEquipLocally:(id)sender;

- (IBAction)buttonActionExportEquip:(id)sender;



// DENNIS stuff - BEGIN

- (void)loadCrewFromServer:(UIButton*)sender;

- (void) addLocationButtons;

- (void) addHelicopterButtons;

- (bool) is_online;

- (void) loadLocationsFromServer;


 - (void) addDispatcherFlightButtons;
- (void) loadDispatcherFlightsFromServer;
@property (weak, nonatomic) IBOutlet UIScrollView *viewDispatcher_sview;


// DENNIS stuff - END

- (IBAction)buttonActionLoadDispatcherFlights:(id)sender;



// views

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewTopDisplayButton;

@property (weak, nonatomic) IBOutlet UIView *viewTopDisplayButtons;

@property (weak, nonatomic) IBOutlet UIView *viewTopTop;

@property (strong, nonatomic) IBOutlet UIView *viewOne;

@property (weak, nonatomic) IBOutlet UIView *viewMain;


@property (weak, nonatomic) IBOutlet UIScrollView *ScrollViewManifest;



@property (weak, nonatomic) IBOutlet UIView *viewLoadManifest;


@property (weak, nonatomic) IBOutlet UIView *viewEnvironment;

@property (weak, nonatomic) IBOutlet UIView *viewSliderISA;

@property (weak, nonatomic) IBOutlet UIView *viewSliderOAT;

@property (strong, nonatomic) IBOutlet UIView *viewSliderPA;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewHeliCenter;

@property (strong, nonatomic) IBOutlet UIView *viewHeliCenterLabels;



// the sliders

@property (weak, nonatomic) IBOutlet UILabel *unitsWeight;
@property (strong, nonatomic) IBOutlet UILabel *labelKgLbsEditStation;
@property (strong, nonatomic) IBOutlet UILabel *labelKgLbsEditStation2;

@property (strong, nonatomic) IBOutlet UILabel *labelKgLbsEditStation3;


@property (strong, nonatomic) IBOutlet UILabel *labelUnitLongEditStation;
@property (strong, nonatomic) IBOutlet UILabel *labelUnitLatEditStation;



@property (weak, nonatomic) IBOutlet UISlider *sliderHp;

- (IBAction)sliderActionHp:(id)sender;




// ENVIRONMENT *********************


@property (weak, nonatomic) IBOutlet UISlider *sliderOATforOGE;

- (IBAction)sliderActionOATforOGE:(id)sender;


@property (strong, nonatomic) IBOutlet UIButton *buttonSetISA;


@property (weak, nonatomic) IBOutlet UILabel *labelISAAnsage;

@property (weak, nonatomic) IBOutlet UILabel *labelDensityAlt;

- (IBAction)buttonActionToggleOATinput:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *labelISAdiff;

@property (weak, nonatomic) IBOutlet UISlider *sliderISADiff;

- (IBAction)sliderActionISAdiff:(id)sender;


@property (weak, nonatomic) IBOutlet UILabel *labelActualOAT;



@property (weak, nonatomic) IBOutlet UILabel *labelDisplayOAT;

@property (weak, nonatomic) IBOutlet UILabel *labelDisplayPA;


@property (weak, nonatomic) IBOutlet UIButton *buttonDisplayEnvironment;

- (IBAction)buttonActionDisplayEnvironment:(id)sender;

- (IBAction)closeKeyboardSaveSeatOptions:(id)sender;


- (IBAction)closeKeyboardEditStations:(id)sender;


- (IBAction)closeKeyboardPressureAlt:(id)sender;


- (IBAction)closeKeyboard:(id)sender;

- (IBAction)closeKeyboardAndSaveFuelDensity:(id)sender;


- (IBAction)closeKeyboardSafetyMargin:(id)sender;


- (IBAction)closeKeyboardPaxEntry:(id)sender;


@property (strong, nonatomic) IBOutlet UIView *viewReserveTimeOnFuelCalc;





// Flight and Callsign

@property (weak, nonatomic) IBOutlet UILabel *Flight;

@property (weak, nonatomic) IBOutlet UILabel *Callsign;






// CG labels

@property (weak, nonatomic) IBOutlet UILabel *labelWeightTakeoff;

@property (weak, nonatomic) IBOutlet UILabel *labelCGTakeoff;



@property (weak, nonatomic) IBOutlet UILabel *labelCGLat;


@property (weak, nonatomic) IBOutlet UILabel *labelWeightLanding;


@property (weak, nonatomic) IBOutlet UILabel *labelWeightZeroFuel;


@property (weak, nonatomic) IBOutlet UILabel *labelCGLanding;


@property (weak, nonatomic) IBOutlet UILabel *labelCGZeroFuel;



@property (weak, nonatomic) IBOutlet UIView *viewSetupButtons;





// cross

@property (weak, nonatomic) IBOutlet UIImageView *crossTOW;

@property (weak, nonatomic) IBOutlet UIImageView *crossZFW;


@property (weak, nonatomic) IBOutlet UIImageView *crossLDW;


@property (weak, nonatomic) IBOutlet UIImageView *crossLatTOW;

@property (weak, nonatomic) IBOutlet UIImageView *crossLatLDW;

@property (weak, nonatomic) IBOutlet UIImageView *crossLatZFW;


/// warnings

@property (weak, nonatomic) IBOutlet UIImageView *warningAS355Pax5;

@property (weak, nonatomic) IBOutlet UILabel *warningCGoutsideEnvelope;

@property (weak, nonatomic) IBOutlet UILabel *warningWeightLimitExceeded;
@property (weak, nonatomic) IBOutlet UILabel *warningLatCGExceeded;


// OGE max  

@property (weak, nonatomic) IBOutlet UILabel *labelOATforOGE;











// button Load Manifest

- (IBAction)buttonActionLoadManifest:(id)sender;

- (IBAction)buttonActionCloseLoadManifest:(id)sender;


// manifest values


@property (weak, nonatomic) IBOutlet UITextField *vBEW;

@property (weak, nonatomic) IBOutlet UITextField *vBEWMom;

@property (weak, nonatomic) IBOutlet UITextField *vBEWMomLat;

@property (weak, nonatomic) IBOutlet UILabel *lBEWArm;

@property (weak, nonatomic) IBOutlet UILabel *lBEWArmLat;







- (IBAction)buttonActionEnterOAT:(id)sender;

- (IBAction)buttonActionEnterISA:(id)sender;





@property (weak, nonatomic) IBOutlet UIButton *buttonOAT;

@property (weak, nonatomic) IBOutlet UIButton *buttonPressureAlt;

@property (weak, nonatomic) IBOutlet UIButton *buttonISA;

// enter Pad

@property (weak, nonatomic) IBOutlet UIView *enterPad;

- (IBAction)padCancelButton:(id)sender;


- (IBAction)padEnterButton:(id)sender;


- (IBAction)buttonDigitPressed:(id)sender;

- (IBAction)buttonComma:(id)sender;

- (IBAction)buttonMinus:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *calculatorscreen;




@property (strong, nonatomic) IBOutlet UILabel *maniFlightIDName;

@property (strong, nonatomic) IBOutlet UILabel *maniLegNumber;


// email

- (IBAction)actionSendManifest:(id)sender;

- (IBAction)actionSendSummary:(id)sender;







@property (weak, nonatomic) IBOutlet UITextField *vFlightDeparture;

@property (weak, nonatomic) IBOutlet UITextField *vFlightDestination;





@property (weak, nonatomic) IBOutlet UITextField *vFlightRegistration;




- (IBAction)buttonActionOpenFlightPage:(id)sender;

- (IBAction)buttonActionOpenMainPage:(id)sender;


- (IBAction)buttonActionNextLeg:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *buttonNextLeg;

- (IBAction)buttonActionPreviousLeg:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *buttonPreviousLeg;

- (IBAction)buttonActionNextFlight:(id)sender;

- (IBAction)buttonActionPreviousFlight:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonDeleteActiveLeg;


@property (weak, nonatomic) IBOutlet UITextField *displayHeliRegistration;




// view SETUP


- (IBAction)actionWebsiteGyroinimo:(UIButton *)sender;

- (IBAction)actionVideoTutorial:(id)sender;

- (IBAction)actionSendEmailAuthor:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonmanifest;

@property (weak, nonatomic) IBOutlet UIButton *buttonSummary;

@property (strong, nonatomic) IBOutlet UIButton *buttonSpecialEquipList;

@property (weak, nonatomic) IBOutlet UIButton *buttonLoadManifest;

@property (weak, nonatomic) IBOutlet UIView *viewSetup;


@property (weak, nonatomic) IBOutlet UIButton *buttonSummaryManifest;

- (IBAction)buttonActionSummaryManifest:(id)sender;



//- (IBAction)setupActionSwitchWarnings:(UISwitch *)sender;


@property (weak, nonatomic) IBOutlet UISwitch *switchNVG;

- (IBAction)switchActionNVG:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *labelNVGpercent;
@property (weak, nonatomic) IBOutlet UISlider *sliderNVG;

- (IBAction)sliderActionNVG:(id)sender;


@property (weak, nonatomic) IBOutlet UISwitch *switchWarnings;

- (IBAction)switchActionWarnings:(id)sender;

@property (weak, nonatomic) IBOutlet UITextField *inputWarningPercentMargin;

- (IBAction)buttonActionDisplaySetup:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonSetup;

@property (weak, nonatomic) IBOutlet UIButton *buttonDisplayFlight;

@property (weak, nonatomic) IBOutlet UIButton *buttonDisplayMainPage;



@property (weak, nonatomic) IBOutlet UITextField *inputFuelFlowOverride;




// email CG


@property (weak, nonatomic) IBOutlet UIView *viewEmailCGEnvelope;

@property (weak, nonatomic) IBOutlet UIImageView *crossMailTow;

@property (weak, nonatomic) IBOutlet UIImageView *crossMailZFW;

@property (weak, nonatomic) IBOutlet UIImageView *crossMailLDW;

@property (weak, nonatomic) IBOutlet UIImageView *crossMailLatCG;



@property (weak, nonatomic) IBOutlet UIImageView *graphicMailCGLAT;






// signature



@property (weak, nonatomic) IBOutlet UIView *viewSignature;


- (IBAction)buttonActionSignatureWindow:(UIButton *)sender;
- (IBAction)buttonActionSignatureSign:(id)sender;
- (IBAction)buttonActionSignatureDelete:(id)sender;
- (IBAction)buttonActionSignatureCancel:(id)sender;


// manifest

@property (strong, nonatomic) IBOutlet UILabel *mani_flightTime;
@property (weak, nonatomic) IBOutlet UILabel *manifestDate;
@property (weak, nonatomic) IBOutlet UILabel *manifestTimeStamp;
@property (weak, nonatomic) IBOutlet UITextField *mani_PilotsName;



// pax input

@property (weak, nonatomic) IBOutlet UIView *viewChangeSelectedEntry;

@property (weak, nonatomic) IBOutlet UIView *viewPilotList;

- (IBAction)buttonActionLoadCrewList:(id)sender;

- (IBAction)actionClosePilotList:(id)sender;

- (IBAction)actionShowPilotList:(id)sender;

@property (nonatomic, weak) IBOutlet UITableView * tableView;


- (IBAction)actionUpdateAircraftList:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *buttonUpdateAircraftList;

- (IBAction)actionCancelEditPilotList:(id)sender;



@property (nonatomic, strong)  NSMutableArray * tableViewDataName;


@property (nonatomic, strong)  NSMutableArray * tableViewDataWeight;



- (IBAction)actionClearSeat:(id)sender;

- (IBAction)actionEnterRideAlong:(id)sender;




// crew and helicopter scrollviews

@property (weak, nonatomic) IBOutlet UIScrollView *crew_locations_sview;
@property (weak, nonatomic) IBOutlet UIScrollView *helicopter_sview;




@property (weak, nonatomic) IBOutlet UITextField *defaultEmailAddress;

@property (weak, nonatomic) IBOutlet UITextField *defaultEmailAddressCC;













// el listo




@property (weak, nonatomic) IBOutlet UIView *viewList;

@property (nonatomic, strong)  NSMutableArray * arrayExternalLoadRestrictions;

@property (nonatomic, strong)  NSMutableArray * arrayName1;

@property (nonatomic, strong)  NSMutableArray * arrayName2;

@property (nonatomic, strong)  NSMutableArray * arrayName3;

@property (nonatomic, strong)  NSMutableArray * arrayName4;

@property (nonatomic, strong)  NSMutableArray * arrayName5;

@property (nonatomic, strong)  NSMutableArray * arrayName6;

@property (nonatomic, strong)  NSMutableArray * arrayName7;

@property (nonatomic, strong)  NSMutableArray * arrayName8;

@property (nonatomic, strong)  NSMutableArray * arrayName9;

@property (nonatomic, strong)  NSMutableArray * arrayName10;

@property (nonatomic, strong)  NSMutableArray * arrayName11;

@property (nonatomic, strong)  NSMutableArray * arrayName12;

@property (nonatomic, strong)  NSMutableArray * arrayName13;

@property (nonatomic, strong)  NSMutableArray * arrayName14;

@property (nonatomic, strong)  NSMutableArray * arrayName15;

@property (nonatomic, strong)  NSMutableArray * arrayName16;

@property (nonatomic, strong)  NSMutableArray * arrayName17;

@property (nonatomic, strong)  NSMutableArray * arrayName18;

@property (nonatomic, strong)  NSMutableArray * arrayName19;
@property (nonatomic, strong)  NSMutableArray * arrayName20;
@property (nonatomic, strong)  NSMutableArray * arrayName21;
@property (nonatomic, strong)  NSMutableArray * arrayName22;
@property (nonatomic, strong)  NSMutableArray * arrayName23;
@property (nonatomic, strong)  NSMutableArray * arrayName24;
@property (nonatomic, strong)  NSMutableArray * arrayName25;


// select Helicopter


@property (weak, nonatomic) IBOutlet UIView *viewSelectHelicopter;

- (IBAction)butSelHeli_Cancel:(id)sender;





@property (weak, nonatomic) IBOutlet UIView *viewLowerButtons;




// new date system

- (IBAction)buttonActionShowPickerTime:(UIButton *)sender;

@property (weak, nonatomic) IBOutlet UIView *viewDatePicker;

@property (weak, nonatomic) IBOutlet UITextField *labelDepartureTimeLocal;

@property (weak, nonatomic) IBOutlet UITextField *labellandingtimeLocal;


@property (weak, nonatomic) IBOutlet UILabel *labelDepartureTimeGMT;








@property (weak, nonatomic) IBOutlet UIButton *buttonONLINEloadCrewList;

@property (strong, nonatomic) IBOutlet UILabel *labelPilotCheck;


// stations window

@property (strong, nonatomic) IBOutlet UIView *viewStationsWindow;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewStations;

@property (strong, nonatomic) IBOutlet UIView *viewStationsSlider;

@property (strong, nonatomic) IBOutlet UIView *viewStationsWindowRight;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewStationsRight;

@property (strong, nonatomic) IBOutlet UIView *viewStationsSliderRight;





@property (strong, nonatomic) IBOutlet UIView *viewManifestListo;


// interior

@property (strong, nonatomic) IBOutlet UIView *viewInterior;


@property (strong, nonatomic) IBOutlet UIView *viewMeasureFrontSeats;

@property (strong, nonatomic) IBOutlet UIView *viewMeasureRearSeats;

@property (strong, nonatomic) IBOutlet UIView *viewMeasureCenter;


@property (strong, nonatomic) IBOutlet UIView *viewMeasureLatRight;

@property (strong, nonatomic) IBOutlet UIView *viewSeatSize;



// configuration

@property (strong, nonatomic) IBOutlet UIView *viewConfigurations;

- (IBAction)buttonActionConfigurations:(id)sender;
- (IBAction)buttonActionConfigurationsFromFlightSettings:(id)sender;

@property (weak, nonatomic) IBOutlet UIView *viewConfigButtons;


// view universal





@property (strong, nonatomic) IBOutlet UISlider *sliderHeadwind2;

@property (strong, nonatomic) IBOutlet UILabel *labelHeadwind2;
- (IBAction)sliderActionHeadwind2:(id)sender;






@property (strong, nonatomic) IBOutlet UITextField *inputSliderIncrement;
@property (strong, nonatomic) IBOutlet UITextField *inputQuickLoadPreset;

// view Options

@property (strong, nonatomic) IBOutlet UIView *viewOptions;




@property (strong, nonatomic) IBOutlet UILabel *lFuelEndurance;

@property (strong, nonatomic) IBOutlet UILabel *lReserveTime;


@property (strong, nonatomic) IBOutlet UIView *viewPerformanceData;


// change Server

- (IBAction)buttonActionChangeServer:(id)sender;


- (IBAction)buttonActionLogInPage:(id)sender;



@property (strong, nonatomic) IBOutlet UILabel *labelServer;

@property (strong, nonatomic) IBOutlet UIView *viewSelectServer;

- (IBAction)buttonActionSelectServer:(id)sender;



// MSL stuff






- (IBAction)sliderActionMSL:(id)sender;

@property (weak, nonatomic) IBOutlet UISlider *sliderMSL;






// QNH

- (IBAction)buttonActionEnterMSLfeet:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterMSLfeet;


@property (weak, nonatomic) IBOutlet UISlider *sliderQNH;

- (IBAction)slideractionQNH:(UISlider *)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterQNH;

- (IBAction)buttonActionEnterQNH:(id)sender;


@property (weak, nonatomic) IBOutlet UILabel *labelQNH;

@property (weak, nonatomic) IBOutlet UILabel *labelQNHEuro;


@property (weak, nonatomic) IBOutlet UILabel *MSLfeet;
@property (strong, nonatomic) IBOutlet UILabel *MSLmeter;

- (IBAction)actionSetISA:(id)sender;

@property (weak, nonatomic) IBOutlet UIView *viewHelicopterInCenter;


@property (weak, nonatomic) IBOutlet UIView *viewFuelPanel;


// new CG envelop

@property (nonatomic, strong)  NSMutableArray * arrayCG1;
@property (nonatomic, strong)  NSMutableArray * arrayCG2;
@property (nonatomic, strong)  NSMutableArray * arrayCG1_LAT;
@property (nonatomic, strong)  NSMutableArray * arrayCG1MarginLine;
@property (nonatomic, strong)  NSMutableArray * arrayCG1_LATline;



@property (strong, nonatomic) IBOutlet UIView *viewCGenvelopeFrame;

@property (strong, nonatomic) IBOutlet UIView *viewCGenvelopeFrame2;

@property (weak, nonatomic) IBOutlet UIView *viewMeasureCGenvelope;

@property (weak, nonatomic) IBOutlet UIView *viewMeasureCGenvelope2;


@property (strong, nonatomic) IBOutlet UIView *viewCGenvelopeFrame_LAT;

@property (strong, nonatomic) IBOutlet UIView *viewCGenvelopeFrame2_LAT;

@property (weak, nonatomic) IBOutlet UIView *viewMeasureCGenvelope_LAT;

@property (weak, nonatomic) IBOutlet UIView *viewMeasureCGenvelope2_LAT;


@property (weak, nonatomic) IBOutlet UIImageView *crossMailLAT;


@property (weak, nonatomic) IBOutlet UIImageView *crossMailLATLDW;

@property (weak, nonatomic) IBOutlet UIImageView *crossMailLATZFW;

@property (weak, nonatomic) IBOutlet UIView *viewFuelPathCG;
@property (weak, nonatomic) IBOutlet UIView *viewFuelPathCGManifest;



@property (weak, nonatomic) IBOutlet UIView *viewFuelPathCGLat;

@property (weak, nonatomic) IBOutlet UIView *viewFuelPathCGManifestLat;



@property (strong, nonatomic) IBOutlet UILabel *labelCGinExtendedEnvelope;
@property (strong, nonatomic) IBOutlet UILabel *labelCGoutsideSafetyMargin;


@property (weak, nonatomic) IBOutlet UIView *cgFreakView;

@property (weak, nonatomic) IBOutlet UIView *cgFreakViewMargin;

- (IBAction)buttonSwitchToRiskPage:(id)sender;


@property (weak, nonatomic) IBOutlet UIImageView *ACtopView;



// dList *****************************************

@property (weak, nonatomic) IBOutlet UIView *viewDlist;


// action depends on location of textfield

- (IBAction)actionEnterText:(UITextField *)sender;

@property (weak, nonatomic) IBOutlet UIView *viewDepartureDestinationFields;




@property (weak, nonatomic) IBOutlet UIView *viewSeatOptions;

- (IBAction)buttonActionCancelSeatOptions:(id)sender;

- (IBAction)buttonActionSaveSeatOptions:(id)sender;


@property (weak, nonatomic) IBOutlet UITextField *inputSeatName;
@property (weak, nonatomic) IBOutlet UITextField *inputSeatWeight;
@property (weak, nonatomic) IBOutlet UITextField *inputSeatMaxWeight;
@property (weak, nonatomic) IBOutlet UITextField *inputInstalledWeight;


@property (weak, nonatomic) IBOutlet UITextField *inputSeatArmLong;
@property (weak, nonatomic) IBOutlet UITextField *inputSeatArmLat;

@property (weak, nonatomic) IBOutlet UITextField *inputSliderMaxWeight;


@property (weak, nonatomic) IBOutlet UIView *viewEditPilotList;


// flight log *********************








@property (weak, nonatomic) IBOutlet UILabel *labelKIAS;

@property (weak, nonatomic) IBOutlet UISlider *sliderKIAS;


- (IBAction)sliderActionKIAS:(id)sender;



// ********************


// fuel sliders


@property (weak, nonatomic) IBOutlet UISlider *sliderFuelMain1;

- (IBAction)sliderActionFuelMain1:(id)sender;


@property (weak, nonatomic) IBOutlet UISlider *sliderFuelLanding;

- (IBAction)sliderActionFuelLanding:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterFuelLanding;


- (IBAction)buttonActionEnterFuelMain:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterFlightTimeMinutes;

- (IBAction)buttonActionEnterFlightTimeMinutes:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *labelFlightTimeMinutes;



@property (weak, nonatomic) IBOutlet UIButton *buttonEnterFuelMain;


- (IBAction)buttonActionEnterFuelLanding:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *labelSliderFuelMain;

@property (weak, nonatomic) IBOutlet UILabel *labelSliderFuelLanding;



@property (weak, nonatomic) IBOutlet UILabel *labelFuelMainPercent;


@property (weak, nonatomic) IBOutlet UILabel *labelFuelLandingPercent;



- (IBAction)buttonActionEnterFuelMainPercent:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterFuelMainPercent;




- (IBAction)buttonActionEnterFuelLandingPercent:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *buttonEnterFuelLandingPercent;



@property (weak, nonatomic) IBOutlet UILabel *labelFlightTime;

@property (weak, nonatomic) IBOutlet UILabel *labelMainFuelOnBar;
@property (weak, nonatomic) IBOutlet UILabel *labelLandingFuelOnBar;


@property (strong, nonatomic) IBOutlet UILabel *labelFuelUnitOnBar;

@property (strong, nonatomic) IBOutlet UIButton *buttonImportPerfData;

@property (strong, nonatomic) IBOutlet UIButton *buttonImportConfigData;


@property (strong, nonatomic) IBOutlet UILabel *labelFuelCompUnitFuelOnBoard;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelCompUnitFuelFlow;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelCompUnitLandingFuel;
@property (strong, nonatomic) IBOutlet UILabel *labelFuelCompUnitRequiredReserve;
@property (strong, nonatomic) IBOutlet UILabel *labelFuelCompUnitRFuelForFlight;

@property (strong, nonatomic) IBOutlet UITextField *labelFuelForFlight;


// Fuel Bar

@property (weak, nonatomic) IBOutlet UIImageView *fuelBarMain;


@property (weak, nonatomic) IBOutlet UIImageView *fuelBarLanding;

@property (weak, nonatomic) IBOutlet UIView *viewTrennerTop;



@property (weak, nonatomic) IBOutlet UIScrollView *scrollViewConfigurations;




@property (strong, nonatomic) IBOutlet UIView *viewVariSlider1;
@property (strong, nonatomic) IBOutlet UIView *viewVariSlider2;
@property (strong, nonatomic) IBOutlet UIView *viewVariSlider3;
@property (strong, nonatomic) IBOutlet UIView *viewVariSlider4;

@property (strong, nonatomic) IBOutlet UILabel *titleVariSlider1;
@property (strong, nonatomic) IBOutlet UILabel *titleVariSlider2;
@property (strong, nonatomic) IBOutlet UILabel *titleVariSlider3;
@property (strong, nonatomic) IBOutlet UILabel *titleVariSlider4;

@property (strong, nonatomic) IBOutlet UILabel *unitVariSlider1;
@property (strong, nonatomic) IBOutlet UILabel *unitVariSlider2;
@property (strong, nonatomic) IBOutlet UILabel *unitVariSlider3;
@property (strong, nonatomic) IBOutlet UILabel *unitVariSlider4;

// options



@property (strong, nonatomic) IBOutlet UILabel *labelFuelUnitMainTank;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelUnitLandingFuel;



@property (strong, nonatomic) IBOutlet UILabel *unitFuelFlow;
@property (strong, nonatomic) IBOutlet UILabel *unitFuelDensity;




@property (weak, nonatomic) IBOutlet UITextField *inputSpecificFuelMassPerVolume;





@property (strong, nonatomic) IBOutlet UILabel *cgFWDlimit;

@property (strong, nonatomic) IBOutlet UILabel *cgAFTlimit;




// portrait landscape items
@property (weak, nonatomic) IBOutlet UIImageView *backgroundMain;

@property (weak, nonatomic) IBOutlet UIButton *triangleWhite;

- (IBAction)actionTrianglePerfButtons:(id)sender;



@property (weak, nonatomic) IBOutlet UIImageView *backgroundFlightPage;

@property (weak, nonatomic) IBOutlet UIImageView *backgroundFlightManager;

@property (weak, nonatomic) IBOutlet UIImageView *backgroundSetupPage;

@property (weak, nonatomic) IBOutlet UIImageView *logoOnly;
@property (strong, nonatomic) IBOutlet UIView *viewLogoOnly;

@property (weak, nonatomic) IBOutlet UIView *viewButtonOATPA;

@property (weak, nonatomic) IBOutlet UILabel *viewButtonOATlabelOAT;

@property (weak, nonatomic) IBOutlet UILabel *viewButtonOATLabelPA;


@property (weak, nonatomic) IBOutlet UIView *trennerBottom;

@property (weak, nonatomic) IBOutlet UIView *viewCGValues;



@property (weak, nonatomic) IBOutlet UIView *viewCGLong;

@property (weak, nonatomic) IBOutlet UIView *viewCGlat;

@property (weak, nonatomic) IBOutlet UIView *trennerVerticalBottom;


@property (weak, nonatomic) IBOutlet UIButton *closeButtonCrewList;

@property (weak, nonatomic) IBOutlet UILabel *labelLoadCrewList;



@property (weak, nonatomic) IBOutlet UIView *viewEnvironmerntButtons;

@property (weak, nonatomic) IBOutlet UIView *viewUniversalExtras;




- (IBAction)actionDisplayTimers:(id)sender;

@property (weak, nonatomic) IBOutlet UIButton *displayButtonTimers;

@property (weak, nonatomic) IBOutlet UIView *viewTimers;



- (IBAction)buttonActionTimer:(id)sender;


@property (weak, nonatomic) IBOutlet UITextField *inputTimer1;
@property (weak, nonatomic) IBOutlet UITextField *inputTimer2;
@property (weak, nonatomic) IBOutlet UITextField *inputTimer3;
@property (weak, nonatomic) IBOutlet UITextField *inputTimer4;
@property (weak, nonatomic) IBOutlet UITextField *inputTimer5;
@property (weak, nonatomic) IBOutlet UITextField *inputTimer6;


@property (strong, nonatomic) IBOutlet UIImageView *mani_LogoOnly;






@property (weak, nonatomic) IBOutlet UIView *viewManifestLowerButtons;

@property (weak, nonatomic) IBOutlet UIView *viewSummaryLowerButtons;






- (IBAction)buttonSwitchToDocumentViewer:(id)sender;







@property (strong, nonatomic) IBOutlet UILabel *labelHOGE_TO_AEO_MAX_WEIGHT;
@property (weak, nonatomic) IBOutlet UILabel *labelTapToCloseFullScreen;


@property (weak, nonatomic) IBOutlet UILabel *labelWeightTakeoff2;

@property (weak, nonatomic) IBOutlet UILabel *labelWeightLanding2;

@property (weak, nonatomic) IBOutlet UITextField *depp;

@property (weak, nonatomic) IBOutlet UILabel *labelExtrasOnHeli;



- (IBAction)actionReloadPerfData:(id)sender;

- (IBAction)actionRestoreConfigsAfterUpdate:(id)sender;


- (IBAction)actionReloadConfigData:(id)sender;

- (IBAction)actionImportConfigDataFromFleetControl:(id)sender;

// altimetry

@property (weak, nonatomic) IBOutlet UIView *viewAltimetry;


@property (weak, nonatomic) IBOutlet UIImageView *graphicHeli;

@property (weak, nonatomic) IBOutlet UIImageView *barHeliMSL;

@property (strong, nonatomic) IBOutlet UILabel *labelOGEceiling;

@property (weak, nonatomic) IBOutlet UIImageView *graphicHpLines;

@property (weak, nonatomic) IBOutlet UIImageView *graphicOGECeiling;

@property (strong, nonatomic) IBOutlet UIButton *buttonCloseInteriorConfigurator;





@property (strong, nonatomic) IBOutlet UILabel *labelAvailableExternalLoad;

@property (strong, nonatomic) IBOutlet UILabel *label2AvailableExternalLoad;

// view specialEquiplist

@property (strong, nonatomic) IBOutlet UIView *viewSpecialEquipLowerTotals;



@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewSpecialEquipList;

@property (strong, nonatomic) IBOutlet UIView *viewSpecialEquiplist;

@property (strong, nonatomic) IBOutlet UIView *viewSpecialEquipItems;

- (IBAction)actionViewSpecialEquipList:(id)sender;

- (IBAction)buttonActionViewEquipmentList:(id)sender;


@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitMass;

@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitLong;
@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitLat;

@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitMass2;

@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitLong2;
@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipUnitLat2;


@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipConfigName;

@property (strong, nonatomic) IBOutlet UILabel *labelSpecialEquipBaseName;


@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalWeight;

@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalArm;

@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalMoment;

@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalArmLat;

@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalMomentLat;


@property (strong, nonatomic) IBOutlet UILabel *labelSEtotalWeight2;



@property (strong, nonatomic) IBOutlet UITextField *input_documentPreparedBy;

@property (strong, nonatomic) IBOutlet UITextField *inputDocumentPreparedDate;


@property (strong, nonatomic) IBOutlet UITextField *inputDocumentPreparedTime;

@property (strong, nonatomic) IBOutlet UIView *viewDocumentPreparedBy;

@property (strong, nonatomic) IBOutlet UIView *viewIntegrityVerification;
@property (strong, nonatomic) IBOutlet UITextField *mani_IntegrityCariedOutOn;

@property (strong, nonatomic) IBOutlet UITextField *mani_IntegrityCarriedOutBy;

- (IBAction)closeKeyboardManifest:(id)sender;
- (IBAction)moveDocPreparedView:(id)sender;



- (IBAction)actionSaveValues:(id)sender;

- (IBAction)sendToGoodReader:(UIButton*)sender;



- (IBAction)actionLoadDispatchFlights:(id)sender;
@property (strong, nonatomic) IBOutlet UITextView *passengerList;
- (IBAction)actionPositionCrewAndPaxFromDispatch:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonImportFlightData;


- (IBAction)actionShowHideDispatch:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewDispatch;

- (IBAction)actionResetApp:(id)sender;


- (IBAction)dropDown1DidEndOnExit:(id)sender;





- (IBAction)actionShowFlightSettings:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewFlightManager;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewFlightButtons;
- (IBAction)actionAddFlight:(id)sender;

@property (strong, nonatomic) IBOutlet UILabel *labelFlightLegID;
@property (strong, nonatomic) IBOutlet UILabel *labelFlightLegID2;

- (IBAction)actionChangeAircraft:(id)sender;




- (IBAction)actionAddLegToActiveFlight:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *buttonAddLeg;

- (IBAction)actionDeleteActiveLeg:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewLegData;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewLegData;




@property (strong, nonatomic) IBOutlet UIView *viewSummaryManifest;

@property (weak, nonatomic) IBOutlet UIView *viewSummaryLegs;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewSummaryManifest;

@property (strong, nonatomic) IBOutlet UIView *viewACViewSettings;
- (IBAction)actionLOGACViewSettings:(id)sender;


@property (strong, nonatomic) IBOutlet UITextField *iacMeasureFrontSeatsY;

@property (strong, nonatomic) IBOutlet UITextField *iacMeasureRearSeatsY;

@property (strong, nonatomic) IBOutlet UITextField *iacSeatWidth;

@property (strong, nonatomic) IBOutlet UITextField *iacSeatHeight;

@property (strong, nonatomic) IBOutlet UITextField *iacLatCenter;

@property (strong, nonatomic) IBOutlet UITextField *iacLatRight;


@property (strong, nonatomic) IBOutlet UITextField *iacACX;

@property (strong, nonatomic) IBOutlet UITextField *iacACY;

@property (strong, nonatomic) IBOutlet UITextField *iacACwidth;

@property (strong, nonatomic) IBOutlet UITextField *iacACheight;


@property (strong, nonatomic) IBOutlet UITextField *iacHeliYUp;


@property (strong, nonatomic) IBOutlet UITextField *iacACType;

@property (strong, nonatomic) IBOutlet UITextField *iacStationID;

@property (strong, nonatomic) IBOutlet UITextField *iacOffsetX;

@property (strong, nonatomic) IBOutlet UITextField *iacOffsetY;


@property (strong, nonatomic) IBOutlet UISwitch *switchAdjustACTopView;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentFuelVolumeOrMass;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentCGAutoCheck;

- (IBAction)actionRunMainRoutine:(id)sender;
- (IBAction)actionConvertFuelFlow:(id)sender;



@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentFlightLegMode;


@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentPlanMode;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewSetupItems;

@property (strong, nonatomic) IBOutlet UIView *viewSetupItems;

@property (strong, nonatomic) IBOutlet UIView *viewLegDataItems;

@property (strong, nonatomic) IBOutlet UITextField *iacSizeX;

@property (strong, nonatomic) IBOutlet UITextField *iacSizeY;

- (IBAction)actionSetFuel:(id)sender;


@property (strong, nonatomic) IBOutlet UIView *viewButtonSet1;

@property (strong, nonatomic) IBOutlet UIView *viewButtonSet2;



@property (strong, nonatomic) IBOutlet UIButton *buttonToggleLegWeights;

@property (strong, nonatomic) IBOutlet UITextField *vFlightIDName;

@property (strong, nonatomic) IBOutlet UITextField *vFlightRemarks;


- (IBAction)closeKeyboardLegData:(id)sender;
- (IBAction)closeKeyboardFlightType:(id)sender;
- (IBAction)closeKeyboardFuelPreset:(id)sender;

- (IBAction)actionDListButton:(id)sender;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentSeatLoadOptions;

- (IBAction)actionSegmentSeatLoadOptions:(id)sender;


- (IBAction)actionSegmentNamesOnSeats:(id)sender;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentNamesOnSeats;




- (IBAction)actionSegmentSwapMode:(id)sender;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentSwapMode;


@property (strong, nonatomic) IBOutlet UIView *viewLegButtons;





@property (strong, nonatomic) IBOutlet UILabel *labelConfigurationName;
@property (strong, nonatomic) IBOutlet UILabel *labelConfigurationName2;




@property (strong, nonatomic) IBOutlet UILabel *labelEquipListName;


- (IBAction)actionShowHidePerformance:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewSelectOptions;

// guidance

@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnSetConfiguration;


@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnSetEquipment;

@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnPerformance;

@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnCrew;
@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnDispatch;

@property (strong, nonatomic) IBOutlet UIButton *guidanceBtnFuelPanel;


@property (strong, nonatomic) IBOutlet UILabel *labelGuidanceOAT;

@property (strong, nonatomic) IBOutlet UILabel *labelGuidancePA;
@property (strong, nonatomic) IBOutlet UISwitch *switchGuidance;
@property (strong, nonatomic) IBOutlet UILabel *labelGuidanceFuel;
@property (strong, nonatomic) IBOutlet UILabel *labelGuidanceLegTime;

@property (strong, nonatomic) IBOutlet UITextField *vEngineStarts1;

@property (strong, nonatomic) IBOutlet UITextField *vEngineStarts2;
@property (strong, nonatomic) IBOutlet UITextField *vRIN;


@property (strong, nonatomic) IBOutlet UITextField *vCockpitSeatLeft;

@property (strong, nonatomic) IBOutlet UITextField *vCockpitSeatRight;

- (IBAction)actionCockpitSeatRight:(id)sender;
- (IBAction)actionCockpitSeatLeft:(id)sender;
- (IBAction)actionCockpitSeatSwap:(id)sender;




// ***** summary


@property (strong, nonatomic) IBOutlet UILabel *sDate;

@property (strong, nonatomic) IBOutlet UILabel *sFlightID;

@property (strong, nonatomic) IBOutlet UILabel *sACtype;

@property (strong, nonatomic) IBOutlet UILabel *sRegistration;

@property (strong, nonatomic) IBOutlet UILabel *sCallsign;

@property (strong, nonatomic) IBOutlet UILabel *sBase;

@property (strong, nonatomic) IBOutlet UILabel *sBEW;

@property (strong, nonatomic) IBOutlet UILabel *sTotalStartsEng1;

@property (strong, nonatomic) IBOutlet UILabel *sTotalStartsEng2;

@property (strong, nonatomic) IBOutlet UILabel *sTotalRIN;

@property (strong, nonatomic) IBOutlet UILabel *sTotalFlightTime;



@property (strong, nonatomic) IBOutlet UILabel *labelPaxOnBoard;


- (IBAction)actionMoveTextfieldUp:(id)sender;


- (IBAction)actionShowConfiguratorView:(id)sender;



@property (strong, nonatomic) IBOutlet UIView *viewConfigurator;

@property (strong, nonatomic) IBOutlet UIView *viewConfiguratorStationItems;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewConfiguratorItems;


@property (strong, nonatomic) IBOutlet UIView *viewConfiguratorTotals;



- (IBAction)actionSaveSummaryAsImage:(id)sender;


@property (strong, nonatomic) IBOutlet UIButton *optionalButtonExportLoadManifestAsPDF;

@property (strong, nonatomic) IBOutlet UIButton *optionalButtonExportSummaryAsPDF;

@property (strong, nonatomic) IBOutlet UIButton *optionalButtonEditConfigurations;

- (IBAction)actionExportSummaryAsPDF:(id)sender;

@property (strong, nonatomic) IBOutlet UITextField *inputSafetyMargin;


@property (strong, nonatomic) IBOutlet UILabel *labelRemovedWgt;
@property (strong, nonatomic) IBOutlet UILabel *labelRemovedArm;
@property (strong, nonatomic) IBOutlet UILabel *labelRemovedMoment;
@property (strong, nonatomic) IBOutlet UILabel *labelRemovedArmLat;
@property (strong, nonatomic) IBOutlet UILabel *labelRemovedMomentLat;

@property (strong, nonatomic) IBOutlet UITextField *inputPaxOnBoard;
- (IBAction)actionBringAllPaxFWD:(id)sender;
- (IBAction)actionBringAllPaxAFT:(id)sender;
- (IBAction)actionBringAllRecall:(id)sender;




@property (strong, nonatomic) IBOutlet UILabel *labelLegManagement;
@property (strong, nonatomic) IBOutlet UIView *viewFlightManagment;
@property (strong, nonatomic) IBOutlet UIView *viewFlightManagment2;


@property (strong, nonatomic) IBOutlet UIView *viewButtonFlightSummary;

@property (strong, nonatomic) IBOutlet UIView *displayButtonFlightSummary;


@property (strong, nonatomic) IBOutlet UITextField *inputOverrideBEW;
@property (strong, nonatomic) IBOutlet UITextField *inputOverrideMoment;
@property (strong, nonatomic) IBOutlet UITextField *inputOverrideMomentLat;
@property (strong, nonatomic) IBOutlet UITextField *inputOverrideRegistration;



- (IBAction)actionOverrideBEWData:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonUseDataForAircraft;


- (IBAction)actionUseEnterPad:(UIButton*)sender;

@property (strong, nonatomic) IBOutlet UILabel *labelCGWarning;





@property (strong, nonatomic) IBOutlet UILabel *labelRegaRemark;

- (IBAction)actionCopyFlightButton:(id)sender;
- (IBAction)actionCopyCurrentFlight:(id)sender;

- (IBAction)actionResetAllFlightsButton:(id)sender;



@property (strong, nonatomic) IBOutlet UITextField *inputFuelOnBoard;

@property (strong, nonatomic) IBOutlet UIView *viewFuelCalc;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelMission;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelReserve;

@property (strong, nonatomic) IBOutlet UILabel *labelFuelEstimatedLanding;


@property (weak, nonatomic) IBOutlet UISwitch *switchAutoLandingFuel;

- (IBAction)switchActionAutoLandingFuel:(id)sender;

@property (strong, nonatomic) IBOutlet UITextField *vFlightTimeHours;

@property (strong, nonatomic) IBOutlet UITextField *vFlightTimeMinutes;

@property (strong, nonatomic) IBOutlet VDTextFieldWithDropDown *vFlightTypeField;

@property (strong, nonatomic) IBOutlet VDTextFieldWithDropDown *vReserveTimeField;

@property (strong, nonatomic) IBOutlet VDTextFieldWithDropDown *vFuelPresetField;


@property (strong, nonatomic) IBOutlet UILabel *labelEnduranceHoursMinutes;


@property (strong, nonatomic) IBOutlet UILabel *warningHoistDAPA;


@property (strong, nonatomic) IBOutlet UIView *viewStationOptions;

@property (strong, nonatomic) IBOutlet UIView *viewStationOptionsList;

- (IBAction)actionCloseStationOptions:(id)sender;

@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentStationItemInOUT;




@property (strong, nonatomic) IBOutlet UILabel *labelStationNameLong;

@property (strong, nonatomic) IBOutlet UITextField *inputStationInstallationWeight;

@property (strong, nonatomic) IBOutlet VDTextFieldWithDropDown *stationTypeField;

- (IBAction)actionStationInOutSingle:(id)sender;


@property (strong, nonatomic) IBOutlet UILabel *labelHeliDataMomentLong;

@property (strong, nonatomic) IBOutlet UILabel *labelHeliDataMass;

@property (strong, nonatomic) IBOutlet UILabel *labelHeliDataMomentLat;


@property (strong, nonatomic) IBOutlet UISwitch *switchRatioForItems;


- (IBAction)actionImportPerfData:(id)sender;


@property (strong, nonatomic) IBOutlet UIImageView *logoManifest;
@property (strong, nonatomic) IBOutlet UIImageView *logoSummary;
@property (strong, nonatomic) IBOutlet UIImageView *logoPowerCheck;


- (IBAction)switchActionMainRoutine:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewOverrideBEWData;

@property (strong, nonatomic) IBOutlet UIView *viewSelectACWindow;


@property (strong, nonatomic) IBOutlet UIView *viewNVGFilterSettings;

@property (strong, nonatomic) IBOutlet UIButton *buttonCancelSelectAC;


@property (strong, nonatomic) IBOutlet UIView *viewButtonsSETUPpage;

@property (strong, nonatomic) IBOutlet UIView *viewButtonsCrewList;



@property (strong, nonatomic) IBOutlet UIView *viewCargoInterior;
- (IBAction)actionViewCargoOrSeatLevel:(id)sender;


@property (strong, nonatomic) IBOutlet UIView *viewFuelSliders;
@property (strong, nonatomic) IBOutlet UIView *viewFuelSettings;

@property (strong, nonatomic) IBOutlet UIView *viewImportPerformanceData;

- (void) deleteAllFlightsWithoutFleetData;

@property (strong, nonatomic) IBOutlet UILabel *labelLogoOnlyACtype;


// power check


@property (strong, nonatomic) IBOutlet UIView *viewPowerCheck;

- (IBAction)actionClosePowerCheck:(id)sender;


@property (weak, nonatomic) IBOutlet UIScrollView *ScrollViewPowerCheck;

@property (strong, nonatomic) IBOutlet UIButton *buttonClosePowerCheck;

@property (strong, nonatomic) IBOutlet UIView *viewPoweCheckButtons;

@property (strong, nonatomic) IBOutlet UILabel *pcPicName;

@property (strong, nonatomic) IBOutlet UILabel *pcAType;
@property (strong, nonatomic) IBOutlet UILabel *pcRegistration;

@property (strong, nonatomic) IBOutlet UILabel *pcTypeOfCheck;
@property (strong, nonatomic) IBOutlet UITextField *pcDate;

@property (strong, nonatomic) IBOutlet UILabel *pcTorque1;
@property (strong, nonatomic) IBOutlet UILabel *pcITT1;
@property (strong, nonatomic) IBOutlet UILabel *pcMaxITT1;
@property (strong, nonatomic) IBOutlet UILabel *pcMMarginITT1;
@property (strong, nonatomic) IBOutlet UILabel *pcResult1;


@property (strong, nonatomic) IBOutlet UILabel *pcTorque2;
@property (strong, nonatomic) IBOutlet UILabel *pcITT2;
@property (strong, nonatomic) IBOutlet UILabel *pcMaxITT2;
@property (strong, nonatomic) IBOutlet UILabel *pcMMarginITT2;
@property (strong, nonatomic) IBOutlet UILabel *pcResult2;

// mountSignatureImageToPowerCheck


- (IBAction)actionSendPowerCheck:(id)sender;





@property (strong, nonatomic) IBOutlet UIView *viewCGLongManifest;

@property (strong, nonatomic) IBOutlet UIView *viewCGLatManifest;

@property (strong, nonatomic) IBOutlet UIView *viewEquipmentOnHeli;



@property (strong, nonatomic) IBOutlet UIView *viewLoadingData;

@property (strong, nonatomic) IBOutlet UIView *viewSetupOptionsForAdmin;

@property (strong, nonatomic) IBOutlet UIView *viewManifestLabels;

@property (strong, nonatomic) IBOutlet UIView *viewManifestBackground;

@property (strong, nonatomic) IBOutlet UIView *viewManifestHeaderFlightData;


@property (strong, nonatomic) IBOutlet UIView *viewManifestHeaderCGEnvelope;


@property (strong, nonatomic) IBOutlet UIView *viewManifestHeaderPerformance;

@property (strong, nonatomic) IBOutlet UIView *viewCGenvelopesManifest;


@property (strong, nonatomic) IBOutlet UIView *setupOptionQuickLoad;
@property (strong, nonatomic) IBOutlet UIView *setupOptionFuelDensity;
@property (strong, nonatomic) IBOutlet UIView *setupOptionPeformanceWarnings;
@property (strong, nonatomic) IBOutlet UIView *setupOptionDataEntryCheck;
@property (strong, nonatomic) IBOutlet UIView *setupOptionSliderIncrement;


@property (strong, nonatomic) IBOutlet UIView *viewSetupOptionsList;


@property (strong, nonatomic) IBOutlet UIView *displayButtonRiskAssessment;

@property (strong, nonatomic) IBOutlet UIView *displayButtonDocumentViewer;


// interior maker

@property (strong, nonatomic) IBOutlet UIView *viewInteriorMakerItems;

@property (strong, nonatomic) IBOutlet UIScrollView *scrollViewInteriorMaker;

- (IBAction)actionToggleStationEquipmentConfigurator:(id)sender;


- (IBAction)actionRefreshInterior:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonRefreshInterior;


@property (strong, nonatomic) IBOutlet UIButton *buttonShowInteriorConfiguratorPage;


@property (strong, nonatomic) IBOutlet UIView *viewLoadingCrewData;


@property (strong, nonatomic) IBOutlet UIActivityIndicatorView *crewDownloadSpinner;

@property (strong, nonatomic) IBOutlet UIActivityIndicatorView *loadDatapinner;





- (IBAction)actionSelectStationAlternate:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonSelectStationAlternate;

@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationName;
@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationNameAlternate;


@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationArmLong;

@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationArmLat;

@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationArmLongAlternate;

@property (strong, nonatomic) IBOutlet UILabel *labelSelectedStationArmLatAlternate;

@property (strong, nonatomic) IBOutlet UIView *viewAlternateStationData;


@property (strong, nonatomic) IBOutlet VDTextFieldWithFixedDropDown *dropDownAvailableACTypes;


- (IBAction)actionDropDownAvailableACTypes:(id)sender;

@property (strong, nonatomic) IBOutlet VDTextFieldWithFixedDropDown *dropDownAvailableCallsigns;

- (IBAction)actionDropDownAvailableCallsigns:(id)sender;


@property (strong, nonatomic) IBOutlet UIView *viewSelectEquipmentFromOtherConfigs;



@property (strong, nonatomic) IBOutlet UILabel *labelAccountName;


- (IBAction)actionCloseSecrectACsettings:(id)sender;



@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentUnitsForItems;

- (IBAction)actionSegmentUnits:(id)sender;



@property (strong, nonatomic) IBOutlet UISegmentedControl *segmentUnitsForFuel;

- (IBAction)actionSegmentFuelUnits:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewSelectorButtons;

@property (strong, nonatomic) IBOutlet UIView *viewFuelUnitButtons;



-(IBAction)sliderActionIAS:(id)sender;

@property (strong, nonatomic) IBOutlet UISlider *sliderIAS;


- (IBAction)sliderActionRatingIndex:(id)sender;

@property (strong, nonatomic) IBOutlet UISlider *sliderRatingIndex;


@property (strong, nonatomic) IBOutlet UILabel *labelSliderIAS;

@property (strong, nonatomic) IBOutlet UILabel *labelSliderRatingIndex;

- (IBAction)sliderActionPROPRPM:(id)sender;

@property (strong, nonatomic) IBOutlet UISlider *sliderPROPRPM;


@property (strong, nonatomic) IBOutlet UILabel *labelSliderPROPRPM;

- (IBAction)actionViewAircraftSetup:(id)sender;

- (IBAction)actionViewAllAvailableAircraft:(id)sender;


@property (strong, nonatomic) IBOutlet UILabel *labelNoPerfCompAvail;

@property (strong, nonatomic) IBOutlet UIView *viewButtonAutoCalcMode;

- (IBAction)buttonActionAutoCalcMode:(id)sender;


@property (strong, nonatomic) IBOutlet UILabel *labelNotePlanMode;
@property (strong, nonatomic) IBOutlet UILabel *labelOATinFahrenheit;
@property (strong, nonatomic) IBOutlet UILabel *labelUnitQNHmain;
@property (strong, nonatomic) IBOutlet UILabel *labelUnitsMSL;
@property (strong, nonatomic) IBOutlet UILabel *labelMainPressureAlt;

@property (strong, nonatomic) IBOutlet UIView *viewGenericACaccess;

@property (strong, nonatomic) IBOutlet UILabel *labelFlightID;
@property (strong, nonatomic) IBOutlet UIView *warningIncreaseLandingFuel;
@property (strong, nonatomic) IBOutlet UIView *viewAutoLandingFuel;
@property (strong, nonatomic) IBOutlet UILabel *labelTotalReserveTime;

@property (strong, nonatomic) IBOutlet UITextField *labelRequiredReserveWeight;
@property (strong, nonatomic) IBOutlet UILabel *labelEnduranceToReserve;
@property (strong, nonatomic) IBOutlet UIView *viewAdditionalFuelInfo;
@property (strong, nonatomic) IBOutlet UILabel *labelAdditionalFuelInfoAvailFlightTime;
@property (strong, nonatomic) IBOutlet UILabel *labelAdditionalFuelInfoReserveTime;
@property (strong, nonatomic) IBOutlet UILabel *labelAdditionalFuelInfoTotalEndurance;
@property (strong, nonatomic) IBOutlet UILabel *labelSupplyFuel;
@property (strong, nonatomic) IBOutlet UILabel *labelMainOnBar;
@property (strong, nonatomic) IBOutlet UILabel *labelUsingSupplyFuelMain;
@property (strong, nonatomic) IBOutlet UILabel *labelUsingSupplyFuelLanding;

@property (strong, nonatomic) IBOutlet UIView *viewFuelPercentage;

@property (strong, nonatomic) IBOutlet UIView *viewRobinsonFuelPanel;

@property (strong, nonatomic) IBOutlet UIImageView *robinsonFuelNeedleMain;
@property (strong, nonatomic) IBOutlet UIImageView *robinsonFuelNeedleAux;
@property (strong, nonatomic) IBOutlet UILabel *labelRobinsonTankMain;
@property (strong, nonatomic) IBOutlet UILabel *labelRobinsonTankAux;
@property (strong, nonatomic) IBOutlet UILabel *labelRobsinonEndurance;

@property (strong, nonatomic) IBOutlet UIView *viewFuelPanelFuelTankSegment;

@property (strong, nonatomic) IBOutlet UIView *viewFuelDensityConversion;
@property (strong, nonatomic) IBOutlet UITextField *inputFuelDensityConverted;
- (IBAction)closeKeyboardAndConvertFuelDensity:(id)sender;
@property (strong, nonatomic) IBOutlet UILabel *unitLabelFuelDenistyConversion;
@property (strong, nonatomic) IBOutlet UIImageView *logoOnlyGyronimo;


@property (strong, nonatomic) IBOutlet UILabel *labelMassOnCGValues;


@property (strong, nonatomic) IBOutlet UILabel *labelCalcMode;
@property (strong, nonatomic) IBOutlet UILabel *labelCalculationMode;
@property (strong, nonatomic) IBOutlet UIButton *buttonCalcMode;


@property (strong, nonatomic) IBOutlet UIView *viewProgress;

@property (strong, nonatomic) IBOutlet UIView *viewLockManifest;

@property (strong, nonatomic) IBOutlet UILabel *labelLockTextOnManifest;

@property (strong, nonatomic) IBOutlet UIView *viewLockPerformance;


@property (strong, nonatomic) IBOutlet UIView *viewAddStation;

@property (strong, nonatomic) IBOutlet UIView *viewCustomStationList;

- (IBAction)actionOpenEditCustomStation:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonOpenCustomStations;

@property (strong, nonatomic) IBOutlet UILabel *labelFlightIDOnSettings;
@property (strong, nonatomic) IBOutlet UILabel *labelFlightTypeOnSettings;
@property (strong, nonatomic) IBOutlet UIView *viewCustomFlightDataElements;

@property (strong, nonatomic) IBOutlet UIView *viewEquipmentListOverManifest;
@property (strong, nonatomic) IBOutlet UILabel *manifestPageNumber;

@property (strong, nonatomic) IBOutlet UIButton *buttonShowHideEquipmentListPage;

- (IBAction)actionShowHideEquipmentListPage:(id)sender;

@property (weak, nonatomic) IBOutlet UILabel *warningLatLimitExceeded;

@property (strong, nonatomic) IBOutlet UIView *viewPHIEquipmentListSelection;

@property (strong, nonatomic) IBOutlet VDTextFieldWithFixedDropDown *dropDownAvailablePHIEquipLists;

- (IBAction)actionDropDownAvailablePHIEquipLists:(id)sender;

- (IBAction)actionDropDownAvailablePHIEquipListsOverride:(id)sender;

- (IBAction)actionDownloadPHIEquipList:(id)sender;

@property (strong, nonatomic) IBOutlet UIView *viewPHIstartScreen;


@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideBEW;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideMoment;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideMomentLat;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideRegistration;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideBase;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideFuelFlow;
@property (strong, nonatomic) IBOutlet VDTextFieldWithFixedDropDown *inputPHIOverrideACtype;
@property (strong, nonatomic) IBOutlet UILabel *phiFuelFlowUnit;
@property (strong, nonatomic) IBOutlet UITextField *inputPHIOverrideSledWeight;

@property (strong, nonatomic) IBOutlet VDTextFieldWithFixedDropDown *dropDownAvailablePHIEquipListsOverride;

@property (strong, nonatomic) IBOutlet UILabel *sHeadlineStart1;
@property (strong, nonatomic) IBOutlet UILabel *sHeadlineStart2;
@property (strong, nonatomic) IBOutlet UILabel *sHeadlineRIN;
@property (strong, nonatomic) IBOutlet UILabel *vHeadlineEngine2;
@property (strong, nonatomic) IBOutlet UILabel *vHeadlineRIN;
@property (strong, nonatomic) IBOutlet UIButton *buttonActionChangeAircraft;


- (IBAction)actionSaveUpdateACdata:(id)sender;
@property (strong, nonatomic) IBOutlet UIButton *buttonSaveUpdateACdata;


@property (strong, nonatomic) IBOutlet UIButton *buttonCreateNewPHIFlight;
- (IBAction)actionCreateNewPHIFlight:(id)sender;

- (IBAction)actionACtypeWasEntered:(id)sender;

- (IBAction)buttonActionUnlockBEWOverride:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonUnlockBEWOverride;
- (IBAction)actionCheckOverrideInputs:(id)sender;
@property (strong, nonatomic) IBOutlet UILabel *labelEquipWarningMessage;

@property (strong, nonatomic) IBOutlet UIButton *optionalButtonUploadSummary;

- (IBAction)actionUploadSummary:(id)sender;


- (IBAction)actionPHICHangeBackToOriginalFormC:(id)sender;

@property (strong, nonatomic) IBOutlet UIButton *buttonPHIchangeBackToOriginalFormC;
@property (strong, nonatomic) IBOutlet UIButton *buttonPHIcancelCreateFlight;
- (IBAction)buttonActionPHIcancelCreateFlight:(id)sender;
@property (strong, nonatomic) IBOutlet UILabel *labelPHIBEWonSummary;

@property (weak, nonatomic) IBOutlet UILabel *lHV0;
@property (weak, nonatomic) IBOutlet UILabel *lHV5;
@property (weak, nonatomic) IBOutlet UILabel *lHV10;
@property (weak, nonatomic) IBOutlet UILabel *lHV15;
@property (weak, nonatomic) IBOutlet UILabel *lHV20;
@property (weak, nonatomic) IBOutlet UILabel *labelNOHVarea;
@property (weak, nonatomic) IBOutlet UIView *viewHVdata;


@property (strong, nonatomic) IBOutlet UIView *viewAddEquipmentItem;

- (IBAction)actionCancelInsertEquipItem:(id)sender;

- (IBAction)actionAddEquipmentItem:(id)sender;

@property (strong, nonatomic) IBOutlet UITextField *inputAddEquipName;
@property (strong, nonatomic) IBOutlet UITextField *inputAddEquipWeight;
@property (strong, nonatomic) IBOutlet UITextField *inputAddEquipArmLong;
@property (strong, nonatomic) IBOutlet UITextField *inputAddEquipArmLat;
@property (strong, nonatomic) IBOutlet UIButton *buttonSignManifest;

@property (strong, nonatomic) IBOutlet UIButton *setToNowButton;

@property (strong, nonatomic) IBOutlet UIButton *buttonSendLoadManifestViaEmail;

@property (strong, nonatomic) IBOutlet UITextField *vFlightTimeMinInput;
@property (strong, nonatomic) IBOutlet UILabel *labelFuelSettingsWarning;

@end
